local mrecipe =
{
	snakebonesoup = 
	{
		test = function(cooker, names, tags) return names.snake_bone and (names.snake_bone == 2 and tags.meat == 2 or(names.snake_bone == 2 and(names.boneshard == 2))) end,
		priority = 20,
		foodtype = "MEAT",
		health = TUNING.HEALING_LARGE,
		hunger = TUNING.CALORIES_MED,
		perishtime = TUNING.PERISH_MED,
		sanity = TUNING.SANITY_SMALL,
		cooktime = 1,
		--
	},

	tea = 
	{
		test = function(cooker, names, tags) return tags.filter and tags.filter >= 2 and tags.sweetener and not tags.meat and not tags.veggie and not tags.inedible end,
		priority = 25,
		foodtype = "MEAT",
		health = TUNING.HEALING_SMALL,
		hunger = TUNING.CALORIES_SMALL,
		perishtime = TUNING.PERISH_ONE_DAY,
		sanity = TUNING.SANITY_LARGE,
		caffeinedelta = TUNING.CAFFEINE_FOOD_BONUS_SPEED/2,
		caffeineduration = TUNING.FOOD_SPEED_LONG/2,		
		temperaturebump = 15,
		antihistamine = 200,
		cooktime = 0.5,
		spoiled_product = "icedtea",
		--
	},	

	icedtea = 
	{
		test = function(cooker, names, tags) return tags.filter and tags.filter >= 2 and tags.sweetener and tags.frozen end,
		priority = 30,
		foodtype = "MEAT",
		health = TUNING.HEALING_SMALL,
		hunger = TUNING.CALORIES_SMALL,
		perishtime = TUNING.PERISH_FAST,
		sanity = TUNING.SANITY_LARGE,
		caffeinedelta = TUNING.CAFFEINE_FOOD_BONUS_SPEED/3,
		caffeineduration = TUNING.FOOD_SPEED_LONG/3,		
		temperaturebump = -10,
		antihistamine = 160,
		cooktime = 0.5,
		--
	},		

	asparagussoup = 
	{
		test = function(cooker, names, tags) return (names.asparagus or names.asparagus_cooked) and names.ice and tags.veggie and tags.veggie > 1 end,
		priority = 10,
		foodtype = "VEGGIE",
		health = TUNING.HEALING_MED,
		hunger = TUNING.CALORIES_MEDSMALL,
		perishtime = TUNING.PERISH_SLOW,
		sanity = TUNING.SANITY_TINY,	
		cooktime = 0.5,
		--
	},	
	hardshell_tacos = 
	{
		test = function(cooker, names, tags) return (names.weevole_carapace == 2 or names.weevole_carapace == 3) and  tags.veggie end,

		priority = 1,
		foodtype = "VEGGIE",
		health = TUNING.HEALING_MED,
		hunger = TUNING.CALORIES_LARGE,
		perishtime = TUNING.PERISH_SLOW,
		sanity = TUNING.SANITY_TINY,
		cooktime = 1,
		--
	},
	
}

for k,v in pairs(mrecipe) do
	v.name = k
	v.weight = v.weight or 1
	v.priority = v.priority or 0
end

return mrecipe